<?php
if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Ubayam extends REF_Controller {
    public function __construct() {
        parent::__construct();
        $this->load->library('upload');
        $this->load->model('ubayam_model', '', TRUE);
        $this->uri_key_index = 0;
    }
    
    public function index() {
        $data = array();
        $data['results'] = $this->ubayam_model->list_all();
        if (!empty($this->session->flashdata('success'))) 
            $data['success'] = $this->session->flashdata('success');
        else 
            $data['error'] = $this->session->flashdata('error');
        
        $actions = $this->actions();
        $data['add_btn']    = 'Create New Ubayam';
        $data['view_link']  = $actions['view'] . '/';
        $data['add_link']   = $actions['add'];
        $data['edit_link']  = $actions['edit'] . '/';
        $data['delete_link']= $actions['delete'] . '/';
        
        $service_menu_id = get_master_controller_id($actions['controller']);
        $data['service_menu_id'] = array('service_menu_id' => $service_menu_id, 'menu_type' => '1');
        $this->render($data, 'ubayam/list');
    }
    
    private function get_ubayam_url_key($name, $id = '') {
        $url_key = get_url_key($name);
        if ($this->ubayam_model->ubayam_url_key_exists($url_key, $id)) {
            $this->uri_key_index ++;
            return $this->get_ubayam_url_key($name . '_' . $this->uri_key_index, $id);
        }
        
        return $url_key;
    }
    
    public function add() {
        $data = array();
        $actions = $this->actions();
        $data['form_action'] = $actions['insert'];
        $this->render($data, 'ubayam/add');
    }
    
    public function insert() {
        $insert = array(
            'ubayakarar_name' => $this->input->post('name'),
            'sanctum_name' => $this->input->post('sanctum_name'),
            'ubayam_name'=> $this->input->post('ubayam_name'),
            'no_of_year' => $this->input->post('no_of_yrs'),
            'class' => $this->input->post('class'),
            'amount' => $this->input->post('ubayam_amount'),
            'phone' => $this->input->post('phone_no'),
            'email' => $this->input->post('email'),
            'address'=> $this->input->post('address'),
            'ubayakar_tamil_name' => htmlspecialchars( $this->input->post('ubayakarar_tamil_name') ),
            'sanctum_tamil_name' => htmlspecialchars( $this->input->post('sanctum_tamil_name') ),
            'tamil_ubayam_name' => htmlspecialchars( $this->input->post('ubayam_tamil_name') ),
            /* 'blk' => $this->input->post('blk'),
            'fax' => $this->input->post('fax'),
            'unit_no' => $this->input->post('unit_no'), */
            'url_key' => $this->get_ubayam_url_key($this->input->post('ubayam_name')),
            'status' => $this->input->post('status'),
            'created_by' => $this->user_data['user_id'],
            'created_on' => date('Y-m-d H:i:s')
        );
        
        $insert_id = $this->ubayam_model->insert($insert);  
        if ($insert_id > 0)
            $this->session->set_flashdata('success', 'Ubayam details added successfully');    
        
        else
            $this->session->set_flashdata('error', 'Ubayam details not added!');
        redirect('ubayam', 'refresh');
    }
    
    public function edit($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $data = array();
        $data['ubayam'] = $this->ubayam_model->get_by_id($id);
        $actions = $this->actions();
        $data['form_action'] = $actions['update'] . '/' . $id;
        $this->render($data, 'ubayam/edit');
    }
    
    public function update($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $update = array(
            'ubayakarar_name' => $this->input->post('name'),
            'sanctum_name' => $this->input->post('sanctum_name'),
            'ubayam_name'=> $this->input->post('ubayam_name'),
            'no_of_year' => $this->input->post('no_of_yrs'),
            'class' => $this->input->post('class'),
            'amount' => $this->input->post('ubayam_amount'),
            'phone' => $this->input->post('phone_no'),
            'email' => $this->input->post('email'),
            'address'=> $this->input->post('address'),
            'ubayakar_tamil_name' => htmlspecialchars( $this->input->post('ubayakarar_tamil_name') ),
            'sanctum_tamil_name' => htmlspecialchars( $this->input->post('sanctum_tamil_name') ),
            'tamil_ubayam_name' => htmlspecialchars( $this->input->post('ubayam_tamil_name') ),
            /* 'blk' => $this->input->post('blk'),
            'fax' => $this->input->post('fax'),
            'unit_no' => $this->input->post('unit_no'), */
            'url_key' => $this->get_ubayam_url_key($this->input->post('ubayam_name')),
            'status' => $this->input->post('status'),
            'updated_by' => $this->user_data['user_id'],
            'updated_on' => date('Y-m-d H:i:s')
        );
        
        
        if ( $this->ubayam_model->update($update, $id) > 0)
            $this->session->set_flashdata('success', 'Ubayam details updated successfully');  
       
        else
            $this->session->set_flashdata('error', 'Ubayam details not updated!');    
        
        redirect('ubayam','refresh');
    }
    
    public function view($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $data = array();
        $data['ubayam'] = $this->ubayam_model->get_by_id($id);
        $this->render($data, 'ubayam/view');
    }
    
    public function delete($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $update = array ( 
            'status' => 2,
            'updated_by' => $this->user_data['user_id'],
            'updated_on' => date('Y-m-d H:i:s')
        );
        
        if ($this->ubayam_model->update($update,$id) > 0)
            $this->session->set_flashdata('success', 'Ubayam details deleted successfully');
            
        else 
            $this->session->set_flashdata('error', 'Ubayam details not deleted!');
        
        redirect( 'ubayam', 'refresh');
    }
}
?>